> For the complete documentation index, see [llms.txt](https://docs.digit.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.digit.org/health/v2.1/design/architecture/field-app-architecture/ui-packages/sync-service-package.md).

# Sync Service Package

The `sync_service` provides access to sync service related configurations and listeners - SyncEntityMapperListener, syncDownRetryCount, persistenceConfiguration

## Features

SyncBloc: Handles refresh and syncup

Data: The `SyncEntityMapperListener` is an abstract class that defines methods for handling sync entity mapping. This class provides methods for writing to the entity database, getting the sync count, handling entity responses, and updating entities. The `SyncService` class provides methods to perform sync operations - performSync, writeToEntityDB, getPendingSyncRecordsCount, filterEntityByBandwidth, filterOpLogByBandwidth, SyncError class

Repositories - RepositoryType - provides methods to get the remote and local repositories for a given data model type - getRemoteForType, getLocalForType PerformSyncDown - provides a method to perform a sync down operation. PerformSyncUp - provides a method to perform a sync up operation.

Models: Bandwidth Model

## Getting Started

To use this package, add the following dependency to your pubspec.yaml file:

```
dependencies:
  sync_service: ^latest
```

## Integrating with the HCM Application

### Usage

Here are some examples of how to use the DataModel package in your project:

Extend the `SyncUpOperation` implement the required methods.

```dart
    class CustomSyncRegistry implements SyncUpOperation {
  CustomSyncRegistry({
    this.remote
  });
}
```

Extend the `SyncEntityMapperListener` class and implement the required methods.

```dart
    class SyncServiceMapper extends SyncEntityMapperListener {
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.digit.org/health/v2.1/design/architecture/field-app-architecture/ui-packages/sync-service-package.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
